-- luaCode to to keep an overview of the zwave variables (Neighbors, WakeupRatings, PollRatings, LastWakeup, ...) of all veraDevices in one table.
-- The result is a csv-file on my webserver, which can be opended as table in OpenOffice (example sie attachment).
-- The data are trasferred per luup.inet.wget to a small script csvVera.php on my webserver (see attachment).
-- # # #
function mySplit(inStr,sep)
	if sep == nil then sep="%s" end
	local t={}; i=1
	for str in string.gmatch(inStr,"([^"..sep.."]+)") do
		t[i] = str
		i = i + 1
	end
	return t
end

function csvLog(arg)
	-- function with one argument, to make "luup.call_delay" possible
	-- in aStr text numbers and spaces are allowed, be carefull with special characters
	local sArg=mySplit(arg,"!")
	local logFile=sArg[1]
	local aStr=sArg[2]
	local aaStr=string.gsub(aStr, "%s+", "+")
	luup.inet.wget("myDomain/path/tabvera.php?tgt=" .. logFile .. "&aStr=" .. aaStr)
end

local idx = {}
for dev in pairs(luup.devices) do
	idx[#idx+1] = dev
end
SID={
HA={"urn:micasaverde-com:serviceId:HaDevice1"},
ZW={"urn:micasaverde-com:serviceId:ZWaveDevice1"},
ZN={"urn:micasaverde-com:serviceId:ZWaveNetwork1"}
}
local cr="%0A"
luup.call_delay("csvLog",0,"log_zwave_vera!" .. os.date("%d, %m, %Y- %H: %M: %S") .. cr)
local hLine="dev;node;name;neighbor;WupInterval;WupRate;wUpLast;BatLevel;PollSet;PollRate;PollOk;PollNoReply;ConsPollFails;PollLast;CommFailure"
luup.call_delay("csvLog",0,"log_zwave_vera!" .. hLine)
local mailStr=""
for _,dev in ipairs(idx) do
	local alarmS=""
	d = luup.devices[dev]
	local descr=d.description
	local Ng=luup.variable_get(SID.ZW[1],"Neighbors",dev) or ""
	local WuI=luup.variable_get(SID.ZW[1],"WakeupInterval",dev) or ""
	local WuR=luup.variable_get(SID.HA[1],"WakeupRatings",dev) or ""
	local lastWake=luup.variable_get(SID.ZW[1],"LastWakeup",dev) or 0
	local BaL=luup.variable_get(SID.HA[1],"BatteryLevel",dev) or ""
	local PoI=luup.variable_get(SID.ZW[1],"PollSettings",dev) or ""
	local PoR=luup.variable_get(SID.HA[1],"PollRatings",dev) or ""
	local Pok=luup.variable_get(SID.ZW[1],"PollOk",dev) or ""
	local PnoR=luup.variable_get(SID.ZW[1],"PollNoReply",dev) or ""
	local PcF=luup.variable_get(SID.ZN[1],"ConsecutivePollFails",dev) or ""
	local lastPoll=luup.variable_get(SID.ZN[1],"LastPollSuccess",dev) or 0
	local ComF=luup.variable_get(SID.HA[1],"CommFailure",dev) or ""
	if WuI == "0" then
		WuR=""
		lastWake="0"
	end
	if lastWake ~= 0 then
		local WaUp=os.date('*t',lastWake)
		lastWake=string.format("%02d",WaUp.month) .. "-" .. string.format("%02d",WaUp.day) .. "_" .. string.format("%02d",WaUp.hour) .. ":" .. string.format("%02d",WaUp.min) .. ":" .. string.format("%02d",WaUp.sec)
	end
	if lastPoll ~= 0 then
		local pLast=os.date('*t',lastPoll)
		lastPoll=string.format("%02d",pLast.month) .. "-" .. string.format("%02d",pLast.day) .. "_" .. string.format("%02d",pLast.hour) .. ":" .. string.format("%02d",pLast.min) .. ":" .. string.format("%02d",pLast.sec)
	end
	local L=";"
	local aStr=dev .. L .. d.id .. L .. descr .. L .. Ng .. L .. WuI .. L .. string.gsub (WuR,"%.","%,") .. L .. lastWake .. L .. BaL
	.. L .. PoI .. L .. PoR .. L .. Pok .. L .. PnoR .. L .. PcF .. L .. lastPoll .. L .. ComF
	if d.id ~= "1" and d.id ~= "" and d.device_num_parent == 1 then
		luup.call_delay("csvLog",1,"log_zwave_vera!" .. aStr)
	end
end